library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

library work;
use work.param_image.all;
use work.types_image.all;

use work.param_predictor.all;

-- Package Declaration Section
package types_predictor is
	
	-- Record for the absolute/relative error limit values
	type err_lim_t is record
		abs_c	: integer range 0 to (2**DA_C-1);
		abs_arr : array_integer_t(0 to NZ_C-1);
		rel_c	: integer range 0 to (2**DR_C-1);
		rel_arr : array_integer_t(0 to NZ_C-1);
	end record err_lim_t;
	
	type s2_pos_t is record
		cur : std_logic_vector(D_C-1 downto 0);
		nw	: std_logic_vector(D_C-1 downto 0);
		n	: std_logic_vector(D_C-1 downto 0);
		ne	: std_logic_vector(D_C-1 downto 0);
		w	: std_logic_vector(D_C-1 downto 0);
		wz	: std_logic_vector(D_C-1 downto 0);
	end record s2_pos_t;

	type ldiff_pos_t is record
		c	: std_logic_vector(D_C+4-1 downto 0);
		n	: std_logic_vector(D_C+4-1 downto 0);
		w	: std_logic_vector(D_C+4-1 downto 0);
		nw	: std_logic_vector(D_C+4-1 downto 0);
	end record ldiff_pos_t;

	-- Arrays record types
	type err_lim_arr_t is array(natural range <>) of err_lim_t;
	type s2_pos_arr_t is array(natural range <>) of s2_pos_t;

end package types_predictor;